package graphs;

import java.util.*;

public class UndirectedCycles {

    public static boolean belongsToCycle(UndirectedGraph g, int vertex) {

        // Metoda urcena na doprogramovanie.

    }

    /**
     * Metoda, ktora precita textovu reprezentaciu neorientovaneho grafu pozostavajucu z poctu vrcholov n, poctu hran m
     * a z m dvojic vrcholov udavajucich jednotlive neorientovane hrany a vytvori podla nej graf urcenej implementacie.
     *
     * @param scanner        Skener, z ktoreho sa reprezentacia grafu cita.
     * @param implementation Implementacia vytvaraneho grafu (zoznamy naslednikov, alebo matica susednosti).
     * @return               Vytvoreny graf.
     */
    public static UndirectedGraph readUndirectedGraph(Scanner scanner, GraphImplementation implementation) {
        int n = scanner.nextInt();
        int m = scanner.nextInt();
        List<UndirectedEdge> edges = new ArrayList<>();
        for (int i = 1; i <= m; i++) {
            edges.add(new UndirectedEdge(scanner.nextInt(), scanner.nextInt()));
        }
        UndirectedGraph g = null;
        switch (implementation) {
            case LISTS:
                g = new AdjacencyListsUndirectedGraph(n, edges);
                break;
            case MATRIX:
                g = new AdjacencyMatrixUndirectedGraph(n, edges);
                break;
        }
        return g;
    }

    /* Metodu main nemente. */
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        UndirectedGraph g = (UndirectedGraph) readUndirectedGraph(scanner, GraphImplementation.LISTS);
        int vertex = scanner.nextInt();
        if (belongsToCycle(g, vertex)) {
            System.out.println("Vrchol " + vertex + " lezi na kruznici.");
        } else {
            System.out.println("Vrchol " + vertex + " nelezi na kruznici.");
        }
    }

}
